;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; A firework demo 
; Programmed by Yaniv LEVIATHAN 
; http://yaniv.leviathanonline.com 
; Converted to DexOS, By Dex 
; Converted to KolibriOS, By Asper
; Assemble with
; c:fasm firework.asm firework.kex
; NOTE: Needs MMX & SSE 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
use32 
	org	0x0

	db	'MENUET00'	; 8 byte id
	dd	38		; required os
	dd	STARTAPP	; program start
	dd	I_END		; program image size
	dd	0x100000	; required amount of memory
	dd	0x00000000	; reserved=no extended header

include "aspAPI.inc"
SCREEN_WIDTH   equ    320
SCREEN_HEIGHT  equ    200
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Global defines 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

   NUM_PARTS   = 150
   X_OFFSET   = 0
   Y_OFFSET   = 2
   X_SPEED_OFFSET   = 4
   Y_SPEED_OFFSET   = 6
   COLOR_OFFSET   = 8
   PART_SIZE   = 10

draw_window:
  start_draw_window 100,70,SCREEN_WIDTH+10,SCREEN_HEIGHT+30,0x04224466,labelt;, 14;labellen-labelt
  end_draw_window
ret


STARTAPP:

init_palette:
   mov edi, pal
   xor ax, ax

red_loop: 
   shl eax, 18
   stosd
   stosd
   shr eax, 18

   inc ax
   cmp al, 64
   jl red_loop 

xor ax, ax 
mov ah, 63 
shl ah, 2

white_loop:
   shl al, 2
   shl eax, 8
   mov al, ah

   stosd
   stosd
   shr eax, 8
   shr al, 2

   inc al
   cmp al, 64
   jl white_loop 

    
zero_buffer: 
   mov ecx, SCREEN_WIDTH*SCREEN_HEIGHT/4
   mov edi,buffer 
   xor eax, eax 
   rep stosb 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
; Main Functions 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
   db 0x0f, 0x31 
   mov [seed], eax 

   jmp MAIN 

init_particle: 
   db 0x0f, 0x31 
   and ax, 0x1F 
jnz .dont_re_init_globals 
   ; init x 
   call rand 
   xor dx, dx 
   mov bx, SCREEN_WIDTH
   div bx 
   shl dx, 6 
   mov [global_x], dx 
   ; init y 
   call rand 
   xor dx, dx 
   mov bx, SCREEN_HEIGHT
   div bx
   shl dx, 6
   mov [global_y], dx 
.dont_re_init_globals: 
   ; init x 
   mov dx, [global_x] 
   mov [ebp+X_OFFSET], dx 
   ; init y 
   mov dx, [global_y] 
   mov [ebp+Y_OFFSET], dx 
   ; init x speed 
   call rand 
   and ax, 31 
   sub ax, 15 
   ;shl ax, 6 
   mov [ebp+X_SPEED_OFFSET], ax 
   ; init y speed 
   call rand 
   and ax, 31 
   sub ax, 15 
   ;shl ax, 6
   mov [ebp+Y_SPEED_OFFSET], ax 
   ; init color 
   mov ax, 255 
   ;call rand
   ;and ax, 0xFF
   mov [ebp+COLOR_OFFSET], ax 
   ret 

red:
   call    draw_window
MAIN:
   mov ecx, NUM_PARTS 
   mov ebp, particles 
   .advance_particles: 
      mov ax, [ebp+X_OFFSET] 
      mov bx, [ebp+Y_OFFSET] 

      sar ax, 6 
      sar bx, 6 

      cmp ax, 5 
      jb .new_particle 
      cmp ax, SCREEN_WIDTH-5;315
      jge .new_particle 
      cmp bx, 5 
      jb .new_particle 
      cmp bx, SCREEN_HEIGHT-5;195
      jge .new_particle 

      jmp .part_ok 

   .new_particle: 
      call init_particle 
      jmp .advance_particles 

   .part_ok: 
      shl eax,16
      shr eax,16
      mov edi, eax 
      add edi,buffer 
      mov eax, SCREEN_WIDTH
      mul bx 
      add edi, eax 
      mov ax, [ebp+COLOR_OFFSET] 
      stosb 

      mov ax, [ebp+X_OFFSET] 
      mov bx, [ebp+Y_OFFSET] 
      add ax, [ebp+X_SPEED_OFFSET] 
      add bx, [ebp+Y_SPEED_OFFSET] 
      mov [ebp+X_OFFSET], ax 
      mov [ebp+Y_OFFSET], bx 

      db 0x0f, 0x31 
      and ax, 0x7F 
      jnz .dont_inc_y_speed 
      inc word [ebp+Y_SPEED_OFFSET] 
      .dont_inc_y_speed: 
    
      add ebp, PART_SIZE 
   loop .advance_particles 

   call mmx_shade 
; jmp .copy_buffer_to_video
   mov eax, [blur_right_flag] 
   and eax, 0x800000 
   jnz .do_blur_right 
   call mmx_blur 
   db 0x0f, 0x31 
   and ax, 1 
   jz .blur_ok 
   jmp .dont_blur 
   .do_blur_right: 
   call mmx_blur_right 
   .blur_ok: 
   mov eax, [blur_right_flag] 
   add eax,0x1000 
   mov [blur_right_flag],   eax 
   .dont_blur: 

   .copy_buffer_to_video: 
    ;    mov     eax, 18 ;@WAITVSYNC();
    ;    mov     ebx, 14
    ;    int     0x40
     ;   mov     eax, 5  ;delay
     ;   mov     ebx, 1
     ;   int     0x40

	mov	eax, 65 ;copyfard(0xA000,0,screen,0,16000);
	mov	ebx, buffer;dword [screen]
	mov	ecx, SCREEN_WIDTH*65536+SCREEN_HEIGHT ;ecx = w*65536+h
	mov	edx, 5*65536+25 ;edx = x*65536+y
	mov	esi, 8
	mov	edi, pal
	xor	ebp, ebp
	int	0x40


still:
	mov	eax, 11 	    ; Test if there is an event in the queue.
	int	0x40

	cmp	al,1		      ; redraw request ?
	jz	red
	cmp	al,2		      ; key in buffer ?
	jz	key
	cmp	al,3		      ; button in buffer ?
	jz	button

	jmp	MAIN


key:
	mov	eax, 2
	int	0x40
	cmp	ah, 1		    ; Test Esc in Scan
	je	close_app
	cmp	ah, 27		    ; Test Esc in ASCII
	je	close_app
	jmp	MAIN

button:
	mov	eax, 17 	    ; Get pressed button code
	int	0x40
	cmp	ah, 1		    ; Test x button
	je	close_app
	jmp	MAIN

fail:
	; Type something here.
close_app:
    mov  eax,-1 		 ; close this program
    int  0x40


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Misc. Functions 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

mmx_shade: 
      mov ecx, SCREEN_WIDTH*SCREEN_HEIGHT/8
      mov  edi,buffer 
      movq mm1, [sub_mask] 
.lop: 
      movq mm0, [es:edi] 
      psubusb mm0, mm1 
      movq [es:edi], mm0 
      add edi, 8 
      loop .lop 
      ret 

mmx_blur: 
      mov ecx, (SCREEN_WIDTH*SCREEN_HEIGHT-330*2)/8
      mov edi, 328 
      add edi,buffer 
.lop: 
      movq mm0, [es:edi] 
      movq mm1, [es:edi+1] 
      movq mm2, [es:edi-1] 
      movq mm3, mm0 
      movq mm4, [es:edi-SCREEN_WIDTH]
      movq mm5, [es:edi+SCREEN_WIDTH]

      pavgb mm0, mm1 ; mm0 = avg(cur,cur+1) 
      pavgb mm3, mm2 ; mm3 = avg(cur,cur-1) 
      pavgb mm4, mm5 ; mm4 = avg(cur+320,cur-320) 
      pavgb mm3, mm4 ; mm3 = avg(avg(cur,cur-1),avg(cur+320,cur-320)) 
      pavgb mm0, mm3 ; mm0 = avg(avg(cur,cur+1), 

      movq [es:edi], mm0 
      add edi, 8 
      loop .lop 
      ret 

mmx_blur_right: 
      mov ecx, (SCREEN_WIDTH*SCREEN_HEIGHT-330*2)/8
      mov edi, 328 
      add edi, buffer
.lop: 
      movq mm0, [es:edi] 
      movq mm1, [es:edi+1]
      movq mm2, [es:edi+SCREEN_WIDTH]
      movq mm3, [es:edi+SCREEN_WIDTH+1]
      pavgb mm0, mm1 
      pavgb mm3, mm2 
      pavgb mm0, mm3 
      movq [es:edi], mm0 
      add edi, 8 
      loop .lop 
      ret 


rand: 
      mov eax, [seed] 
      imul eax, 214013 
      add eax, 2531011 
      mov [seed], eax 
      shr eax, 16 
      ret 

; DATA AREA

; Application Title
labelt		db	'Firework demo',0
;labelt          db      'Matrix demo',0


seed:	     dd 0
global_x:    dw 160*64 
global_y:    dw 100*64 
sub_mask:    dd 0x01010101, 0x01010101 
;                             x, y, x_speed, y_speed, color 
particles: times NUM_PARTS dw 0, 0, 0,	      0,       0 
blur_right_flag: dd 0 
;include 'Dex.inc'
I_END:
pal	     rb 256*4	;dup(0)
;pal             dd      256   dup(0)
;buffer       rb 1024*64
buffer	     rb SCREEN_WIDTH*SCREEN_HEIGHT
